﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;

namespace ButtonInNewlyAddedRow
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private bool IsSavingAllowed = false;
        public MainWindow()
        {
            InitializeComponent();

            DataContext = new ObservableCollection<Data>
            {
                new Data { ID = 1, Name = "Name 1" },
                new Data { ID = 2, Name = "Name 2" },
                new Data { ID = 3, Name = "Name 3" },
                new Data { ID = 4, Name = "Name 4" },
                new Data { ID = 5, Name = "Name 5" },
            };
        }

        private void save_Click(object sender, RoutedEventArgs e)
        {
            DataRecord rec = (sender as Button).DataContext as DataRecord;
            rec.Tag = "notNew";
        }

        private void XamDataGrid_InitializeRecord(object sender, Infragistics.Windows.DataPresenter.Events.InitializeRecordEventArgs e)
        {
            if (IsSavingAllowed)
            {
                if (e.Record.Tag == null)
                    e.Record.Tag = "IsNew";
            }
            else
            {
                e.Record.Tag = "notNew";
                if (e.Record.Index == e.Record.DataPresenter.Records.Count - 1)
                    IsSavingAllowed = true;
            }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            (DataContext as ObservableCollection<Data>).Add(new Data { ID = -1, Name = "New" });
        }
    }

    public class Data
    {
        public int ID { get; set; }
        public string Name { get; set; }
    }
}
